/**
   @author Shin'ichiro Nakaoka
*/

#ifndef CNOID_BODYPLUGIN_SIMULATION_BAR_H_INCLUDED
#define CNOID_BODYPLUGIN_SIMULATION_BAR_H_INCLUDED

#include <cnoid/ToolBar>
#include <boost/function.hpp>
#include <iosfwd>

namespace cnoid {

    class SimulatorItem;

    class SimulationBar : public ToolBar
    {
    public:

        static SimulationBar* initialize(ExtensionManager* ext);
        static SimulationBar* instance();
            
        virtual ~SimulationBar();

    private:

        SimulationBar();

        void onStoreInitialClicked();
        void onRestoreInitialClicked();
        void forEachSimulator(boost::function<void(SimulatorItem* simulator)> callback);
        void startSimulation(SimulatorItem* simulator, bool doRest);
        void onStopSimulationClicked();
        void stopSimulation(SimulatorItem* simulator);

        std::ostream& os;
    };
}

#endif
