/*!
  @file
  @author Shin'ichiro Nakaoka
*/

#include "ODESimulatorItem.h"
#include <cnoid/Plugin>
#include <ode/ode.h>

using namespace std;
using namespace cnoid;

namespace {
    
    class ODEPlugin : public Plugin
    {
    public:
        ODEPlugin() : Plugin("ODE")
        { 
            require("Body");
        }
        
        virtual ~ODEPlugin()
        {

        }

        virtual bool initialize()
        {
            dInitODE2(0);
            dAllocateODEDataForThread(dAllocateMaskAll);

            ODESimulatorItem::initialize(this);
            
            return true;
        }
        
        virtual bool finalize()
        {
            dCloseODE();
            return true;
        }
    };
}

CNOID_IMPLEMENT_PLUGIN_ENTRY(ODEPlugin);
